#define _POSIX_C_SOURCE 200809L

#include <lektor/common.h>
#include <lektor/database.h>
#include <lektor/internal/dbmacro.h>

bool
database_user_authentificate(lkt_db *db, const char *password)
{
    static const char *SQL_STMT = "SELECT username FROM users WHERE password = ?";
    sqlite3_stmt *stmt          = 0;
    bool ret                    = false;
    SQLITE_PREPARE(db, stmt, SQL_STMT, error);
    SQLITE_BIND_TEXT(db, stmt, 1, password, error);
    SQLITE_STEP_ROW(db, stmt, error);
    LOG_INFO("DB", "User authentification for '%s'", sqlite3_column_text(stmt, 0));
    ret = true;
error:
    sqlite3_finalize(stmt);
    return ret;
}

bool
database_user_add(lkt_db *db, const char *username, const char *password)
{
    static const char *SQL_STMT = "INSERT INTO users (username, password) VALUES (?, ?)";
    sqlite3_stmt *stmt          = 0;
    bool ret                    = false;
    SQLITE_PREPARE(db, stmt, SQL_STMT, error);
    SQLITE_BIND_TEXT(db, stmt, 1, username, error);
    SQLITE_BIND_TEXT(db, stmt, 2, password, error);
    SQLITE_STEP_DONE(db, stmt, error);
    LOG_INFO("DB", "User '%s' successfully added", username);
    ret = true;
error:
    sqlite3_finalize(stmt);
    return ret;
}
