#pragma once

#include <mpv/client.h>
#include <lektor/common.h>
#include <lektor/queue.h>
#include <lektor/reg.h>
#include <lektor/database.h>

void lmpv_free(mpv_handle **ctx);
mpv_handle *lmpv_new(unsigned long int wid, lkt_db *db);
int lmpv_observe_properties(mpv_handle *ctx);
mpv_handle *lmpv_prepare(lkt_db *db);

int lmpv_set_volume(mpv_handle *ctx, int vol);
int lmpv_set_position(mpv_handle *ctx, int pos);
int lmpv_load_file(mpv_handle *ctx, const char *file);
int lmpv_toggle_pause(mpv_handle *ctx);

struct lmpv_handle_arg {
    volatile int *time_pos;
    volatile int *time_duration;
    volatile int *state;
    volatile int *hinib;
    volatile int *set_seek;
};
int lmpv_handle(struct lkt_module *mod, mpv_handle *ctx, struct queue *queue,
                struct lmpv_handle_arg *);

enum {
    STATE_STOP  = 0,
    STATE_PLAY  = 1,
    STATE_PAUSE = 2,
};

#define SET_STATE_FLAG(sta, STATUS) \
    (LOG_DEBUG("WINDOW", "Set status flag to " #STATUS), (sta) = STATE_##STATUS)
